import{s as Te,f as P,n as ze,o as $e}from"../chunks/scheduler.37c15a92.js";import{S as Ee,i as Pe,g as n,s as p,r as qt,m as c,H as u,A as Se,h as l,f as s,c as m,j as h,u as jt,x as r,n as o,B as v,k as g,y as i,a as e,v as Gt,d as Rt,t as Ot,w as Ut}from"../chunks/index.7cb9c9b8.js";import{H as ea,E as He}from"../chunks/EditOnGithub.858acfec.js";function Ie(Ma){let x,Nt,zt,Qt,S,Ft,H,Vt,I,ka="The solution to reducing the variance of the Reinforce algorithm and training our agent faster and better is to use a combination of Policy-Based and Value-Based methods: <em>the Actor-Critic method</em>.",Bt,q,Aa="To understand the Actor-Critic, imagine you’re playing a video game. You can play with a friend that will provide you with some feedback. You’re the Actor and your friend is the Critic.",Yt,j,La,Wt,G,Ta="You don’t know how to play at the beginning, <strong>so you try some actions randomly</strong>. The Critic observes your action and <strong>provides feedback</strong>.",Dt,R,za="Learning from this feedback, <strong>you’ll update your policy and be better at playing that game.</strong>",Jt,O,$a="On the other hand, your friend (Critic) will also update their way to provide feedback so it can be better next time.",Kt,U,Ea="This is the idea behind Actor-Critic. We learn two function approximations:",Xt,A,$t,y,rt,Pa="A policy",na,ct,Sa="controls how our agent acts",la,Zt,ge='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\pi_{\\theta}(s) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',ia,Et,N,ot,Ha="A value function",pa,ts,ue='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mover accent="true"><mi>q</mi><mo>^</mo></mover><mi>w</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\hat{q}_{w}(s,a) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">q</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.1667em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.1514em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02691em;">w</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',ss,Q,as,F,Ia="Now that we have seen the Actor Critic’s big picture, let’s dive deeper to understand how the Actor and Critic improve together during the training.",es,V,qa="As we saw, with Actor-Critic methods, there are two function approximations (two neural networks):",ns,L,_,ht,ja="Actor",ma,gt,Ga="policy function",ra,ls,ve='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\pi_{\\theta}(s) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',ca,b,ut,Ra="Critic",oa,vt,Oa="value function",ha,is,de='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mover accent="true"><mi>q</mi><mo>^</mo></mover><mi>w</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\hat{q}_{w}(s,a) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">q</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.1667em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.1514em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02691em;">w</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',ps,B,Ua="Let’s see the training process to understand how the Actor and Critic are optimized:",ms,T,Pt,C,ga,rs,fe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> S_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',cs,dt,Na="pass it as input through our Actor and Critic",ua,va,St,M,da,ft,Qa="outputs an action",fa,os,we='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',hs,gs,Y,Fa,us,wt,d,wa,vs,xe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> S_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ds,fs,ye='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ws,xt,Va="computes the value of taking that action at that state: the Q-value",xa,xs,W,Ba,ys,yt,f,ya,_s,_e='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',bs,Cs,be='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Ms,ks,Ce='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> R_{t+1} </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',As,Ls,D,Ya,Ts,J,Wa="<li>The Actor updates its policy parameters using the Q value.</li>",zs,K,Da,$s,z,Ht,k,_a,Es,Me='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> A_{t+1} </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Ps,Ss,ke='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> S_{t+1} </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Hs,ba,_t,Ja="<p>The Critic then updates its value parameters.</p>",Is,X,Ka,qs,Z,js,tt,Xa="We can stabilize learning further by <strong>using the Advantage function as Critic instead of the Action value function</strong>.",Gs,st,Za="The idea is that the Advantage function calculates the relative advantage of an action compared to the others possible at a state: <strong>how taking that action at a state is better compared to the average value of the state</strong>. It’s subtracting the mean value of the state from the state action pair:",Rs,at,te,Os,et,se="In other words, this function calculates <strong>the extra reward we get if we take this action at that state compared to the mean reward we get at that state</strong>.",Us,nt,ae="The extra reward is what’s beyond the expected value of that state.",Ns,lt,ee="<li>If A(s,a) &gt; 0: our gradient is <strong>pushed in that direction</strong>.</li> <li>If A(s,a) &lt; 0 (our action does worse than the average value of that state), <strong>our gradient is pushed in the opposite direction</strong>.</li>",Qs,w,Ca,Fs,Ae='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> Q(s,a)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',Vs,Bs,Le='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> V(s)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',Ys,bt,ne="we can use the TD error as a good estimator of the advantage function.",Ws,it,le,Ds,pt,Js,It,Ks;return S=new ea({props:{title:"Advantage Actor-Critic (A2C)",local:"advantage-actor-critic",headingTag:"h1"}}),H=new ea({props:{title:"Reducing variance with Actor-Critic methods",local:"reducing-variance-with-actor-critic-methods",headingTag:"h2"}}),Q=new ea({props:{title:"The Actor-Critic Process",local:"the-actor-critic-process",headingTag:"h2"}}),Z=new ea({props:{title:"Adding Advantage in Actor-Critic (A2C)",local:"adding-advantage-in-actor-critic-a2c",headingTag:"h2"}}),pt=new He({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit6/advantage-actor-critic.mdx"}}),{c(){x=n("meta"),Nt=p(),zt=n("p"),Qt=p(),qt(S.$$.fragment),Ft=p(),qt(H.$$.fragment),Vt=p(),I=n("p"),I.innerHTML=ka,Bt=p(),q=n("p"),q.textContent=Aa,Yt=p(),j=n("img"),Wt=p(),G=n("p"),G.innerHTML=Ta,Dt=p(),R=n("p"),R.innerHTML=za,Jt=p(),O=n("p"),O.textContent=$a,Kt=p(),U=n("p"),U.textContent=Ea,Xt=p(),A=n("ul"),$t=n("li"),y=n("p"),rt=n("em"),rt.textContent=Pa,na=c(" that "),ct=n("strong"),ct.textContent=Sa,la=c(":"),Zt=new u(!1),ia=p(),Et=n("li"),N=n("p"),ot=n("em"),ot.textContent=Ha,pa=c(" to assist the policy update by measuring how good the action taken is:"),ts=new u(!1),ss=p(),qt(Q.$$.fragment),as=p(),F=n("p"),F.textContent=Ia,es=p(),V=n("p"),V.textContent=qa,ns=p(),L=n("ul"),_=n("li"),ht=n("em"),ht.textContent=ja,ma=c(", a "),gt=n("strong"),gt.textContent=Ga,ra=c(" parameterized by theta:"),ls=new u(!1),ca=p(),b=n("li"),ut=n("em"),ut.textContent=Ra,oa=c(", a "),vt=n("strong"),vt.textContent=Oa,ha=c(" parameterized by w:"),is=new u(!1),ps=p(),B=n("p"),B.textContent=Ua,ms=p(),T=n("ul"),Pt=n("li"),C=n("p"),ga=c("At each timestep, t, we get the current state"),rs=new u(!1),cs=c(" from the environment and "),dt=n("strong"),dt.textContent=Na,ua=c("."),va=p(),St=n("li"),M=n("p"),da=c("Our Policy takes the state and "),ft=n("strong"),ft.textContent=Qa,fa=p(),os=new u(!1),hs=c("."),gs=p(),Y=n("img"),us=p(),wt=n("ul"),d=n("li"),wa=c("The Critic takes that action also as input and, using"),vs=new u(!1),ds=c(" and"),fs=new u(!1),ws=c(", "),xt=n("strong"),xt.textContent=Va,xa=c("."),xs=p(),W=n("img"),ys=p(),yt=n("ul"),f=n("li"),ya=c("The action"),_s=new u(!1),bs=c(" performed in the environment outputs a new state"),Cs=new u(!1),Ms=c(" and a reward"),ks=new u(!1),As=c(" ."),Ls=p(),D=n("img"),Ts=p(),J=n("ul"),J.innerHTML=Wa,zs=p(),K=n("img"),$s=p(),z=n("ul"),Ht=n("li"),k=n("p"),_a=c("Thanks to its updated parameters, the Actor produces the next action to take at"),Es=new u(!1),Ps=c(" given the new state"),Ss=new u(!1),Hs=c("."),ba=p(),_t=n("li"),_t.innerHTML=Ja,Is=p(),X=n("img"),qs=p(),qt(Z.$$.fragment),js=p(),tt=n("p"),tt.innerHTML=Xa,Gs=p(),st=n("p"),st.innerHTML=Za,Rs=p(),at=n("img"),Os=p(),et=n("p"),et.innerHTML=se,Us=p(),nt=n("p"),nt.textContent=ae,Ns=p(),lt=n("ul"),lt.innerHTML=ee,Qs=p(),w=n("p"),Ca=c("The problem with implementing this advantage function is that it requires two value functions — "),Fs=new u(!1),Vs=c(" and "),Bs=new u(!1),Ys=c(". Fortunately, "),bt=n("strong"),bt.textContent=ne,Ws=p(),it=n("img"),Ds=p(),qt(pt.$$.fragment),Js=p(),It=n("p"),this.h()},l(t){const a=Se("svelte-u9bgzb",document.head);x=l(a,"META",{name:!0,content:!0}),a.forEach(s),Nt=m(t),zt=l(t,"P",{}),h(zt).forEach(s),Qt=m(t),jt(S.$$.fragment,t),Ft=m(t),jt(H.$$.fragment,t),Vt=m(t),I=l(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-krwho4"&&(I.innerHTML=ka),Bt=m(t),q=l(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-hd3rkl"&&(q.textContent=Aa),Yt=m(t),j=l(t,"IMG",{src:!0,alt:!0}),Wt=m(t),G=l(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1lbzw5w"&&(G.innerHTML=Ta),Dt=m(t),R=l(t,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1g68qqi"&&(R.innerHTML=za),Jt=m(t),O=l(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1i1ihbx"&&(O.textContent=$a),Kt=m(t),U=l(t,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1fcp10q"&&(U.textContent=Ea),Xt=m(t),A=l(t,"UL",{});var Xs=h(A);$t=l(Xs,"LI",{});var ie=h($t);y=l(ie,"P",{});var Ct=h(y);rt=l(Ct,"EM",{"data-svelte-h":!0}),r(rt)!=="svelte-1q5uc95"&&(rt.textContent=Pa),na=o(Ct," that "),ct=l(Ct,"STRONG",{"data-svelte-h":!0}),r(ct)!=="svelte-9j9b6"&&(ct.textContent=Sa),la=o(Ct,":"),Zt=v(Ct,!1),Ct.forEach(s),ie.forEach(s),ia=m(Xs),Et=l(Xs,"LI",{});var pe=h(Et);N=l(pe,"P",{});var Zs=h(N);ot=l(Zs,"EM",{"data-svelte-h":!0}),r(ot)!=="svelte-1lxl85o"&&(ot.textContent=Ha),pa=o(Zs," to assist the policy update by measuring how good the action taken is:"),ts=v(Zs,!1),Zs.forEach(s),pe.forEach(s),Xs.forEach(s),ss=m(t),jt(Q.$$.fragment,t),as=m(t),F=l(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1c7kje2"&&(F.textContent=Ia),es=m(t),V=l(t,"P",{"data-svelte-h":!0}),r(V)!=="svelte-eu7748"&&(V.textContent=qa),ns=m(t),L=l(t,"UL",{});var ta=h(L);_=l(ta,"LI",{});var Mt=h(_);ht=l(Mt,"EM",{"data-svelte-h":!0}),r(ht)!=="svelte-1df5trl"&&(ht.textContent=ja),ma=o(Mt,", a "),gt=l(Mt,"STRONG",{"data-svelte-h":!0}),r(gt)!=="svelte-m02j94"&&(gt.textContent=Ga),ra=o(Mt," parameterized by theta:"),ls=v(Mt,!1),Mt.forEach(s),ca=m(ta),b=l(ta,"LI",{});var kt=h(b);ut=l(kt,"EM",{"data-svelte-h":!0}),r(ut)!=="svelte-18wqahq"&&(ut.textContent=Ra),oa=o(kt,", a "),vt=l(kt,"STRONG",{"data-svelte-h":!0}),r(vt)!=="svelte-1fbqdkf"&&(vt.textContent=Oa),ha=o(kt," parameterized by w:"),is=v(kt,!1),kt.forEach(s),ta.forEach(s),ps=m(t),B=l(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-qos3jx"&&(B.textContent=Ua),ms=m(t),T=l(t,"UL",{});var sa=h(T);Pt=l(sa,"LI",{});var me=h(Pt);C=l(me,"P",{});var At=h(C);ga=o(At,"At each timestep, t, we get the current state"),rs=v(At,!1),cs=o(At," from the environment and "),dt=l(At,"STRONG",{"data-svelte-h":!0}),r(dt)!=="svelte-7r20hj"&&(dt.textContent=Na),ua=o(At,"."),At.forEach(s),me.forEach(s),va=m(sa),St=l(sa,"LI",{});var re=h(St);M=l(re,"P",{});var Lt=h(M);da=o(Lt,"Our Policy takes the state and "),ft=l(Lt,"STRONG",{"data-svelte-h":!0}),r(ft)!=="svelte-10nn435"&&(ft.textContent=Qa),fa=m(Lt),os=v(Lt,!1),hs=o(Lt,"."),Lt.forEach(s),re.forEach(s),sa.forEach(s),gs=m(t),Y=l(t,"IMG",{src:!0,alt:!0}),us=m(t),wt=l(t,"UL",{});var ce=h(wt);d=l(ce,"LI",{});var $=h(d);wa=o($,"The Critic takes that action also as input and, using"),vs=v($,!1),ds=o($," and"),fs=v($,!1),ws=o($,", "),xt=l($,"STRONG",{"data-svelte-h":!0}),r(xt)!=="svelte-uggext"&&(xt.textContent=Va),xa=o($,"."),$.forEach(s),ce.forEach(s),xs=m(t),W=l(t,"IMG",{src:!0,alt:!0}),ys=m(t),yt=l(t,"UL",{});var oe=h(yt);f=l(oe,"LI",{});var E=h(f);ya=o(E,"The action"),_s=v(E,!1),bs=o(E," performed in the environment outputs a new state"),Cs=v(E,!1),Ms=o(E," and a reward"),ks=v(E,!1),As=o(E," ."),E.forEach(s),oe.forEach(s),Ls=m(t),D=l(t,"IMG",{src:!0,alt:!0}),Ts=m(t),J=l(t,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-1xd4i4c"&&(J.innerHTML=Wa),zs=m(t),K=l(t,"IMG",{src:!0,alt:!0}),$s=m(t),z=l(t,"UL",{});var aa=h(z);Ht=l(aa,"LI",{});var he=h(Ht);k=l(he,"P",{});var Tt=h(k);_a=o(Tt,"Thanks to its updated parameters, the Actor produces the next action to take at"),Es=v(Tt,!1),Ps=o(Tt," given the new state"),Ss=v(Tt,!1),Hs=o(Tt,"."),Tt.forEach(s),he.forEach(s),ba=m(aa),_t=l(aa,"LI",{"data-svelte-h":!0}),r(_t)!=="svelte-orop3a"&&(_t.innerHTML=Ja),aa.forEach(s),Is=m(t),X=l(t,"IMG",{src:!0,alt:!0}),qs=m(t),jt(Z.$$.fragment,t),js=m(t),tt=l(t,"P",{"data-svelte-h":!0}),r(tt)!=="svelte-e76jc2"&&(tt.innerHTML=Xa),Gs=m(t),st=l(t,"P",{"data-svelte-h":!0}),r(st)!=="svelte-1ihnygk"&&(st.innerHTML=Za),Rs=m(t),at=l(t,"IMG",{src:!0,alt:!0}),Os=m(t),et=l(t,"P",{"data-svelte-h":!0}),r(et)!=="svelte-1y9z9x3"&&(et.innerHTML=se),Us=m(t),nt=l(t,"P",{"data-svelte-h":!0}),r(nt)!=="svelte-102uivm"&&(nt.textContent=ae),Ns=m(t),lt=l(t,"UL",{"data-svelte-h":!0}),r(lt)!=="svelte-9js17k"&&(lt.innerHTML=ee),Qs=m(t),w=l(t,"P",{});var mt=h(w);Ca=o(mt,"The problem with implementing this advantage function is that it requires two value functions — "),Fs=v(mt,!1),Vs=o(mt," and "),Bs=v(mt,!1),Ys=o(mt,". Fortunately, "),bt=l(mt,"STRONG",{"data-svelte-h":!0}),r(bt)!=="svelte-a0qaqz"&&(bt.textContent=ne),mt.forEach(s),Ws=m(t),it=l(t,"IMG",{src:!0,alt:!0}),Ds=m(t),jt(pt.$$.fragment,t),Js=m(t),It=l(t,"P",{}),h(It).forEach(s),this.h()},h(){g(x,"name","hf:doc:metadata"),g(x,"content",qe),P(j.src,La="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/ac.jpg")||g(j,"src",La),g(j,"alt","Actor Critic"),Zt.a=null,ts.a=null,ls.a=null,is.a=null,rs.a=cs,os.a=hs,P(Y.src,Fa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step1.jpg")||g(Y,"src",Fa),g(Y,"alt","Step 1 Actor Critic"),vs.a=ds,fs.a=ws,P(W.src,Ba="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step2.jpg")||g(W,"src",Ba),g(W,"alt","Step 2 Actor Critic"),_s.a=bs,Cs.a=Ms,ks.a=As,P(D.src,Ya="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step3.jpg")||g(D,"src",Ya),g(D,"alt","Step 3 Actor Critic"),P(K.src,Da="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step4.jpg")||g(K,"src",Da),g(K,"alt","Step 4 Actor Critic"),Es.a=Ps,Ss.a=Hs,P(X.src,Ka="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step5.jpg")||g(X,"src",Ka),g(X,"alt","Step 5 Actor Critic"),P(at.src,te="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/advantage1.jpg")||g(at,"src",te),g(at,"alt","Advantage Function"),Fs.a=Vs,Bs.a=Ys,P(it.src,le="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/advantage2.jpg")||g(it,"src",le),g(it,"alt","Advantage Function")},m(t,a){i(document.head,x),e(t,Nt,a),e(t,zt,a),e(t,Qt,a),Gt(S,t,a),e(t,Ft,a),Gt(H,t,a),e(t,Vt,a),e(t,I,a),e(t,Bt,a),e(t,q,a),e(t,Yt,a),e(t,j,a),e(t,Wt,a),e(t,G,a),e(t,Dt,a),e(t,R,a),e(t,Jt,a),e(t,O,a),e(t,Kt,a),e(t,U,a),e(t,Xt,a),e(t,A,a),i(A,$t),i($t,y),i(y,rt),i(y,na),i(y,ct),i(y,la),Zt.m(ge,y),i(A,ia),i(A,Et),i(Et,N),i(N,ot),i(N,pa),ts.m(ue,N),e(t,ss,a),Gt(Q,t,a),e(t,as,a),e(t,F,a),e(t,es,a),e(t,V,a),e(t,ns,a),e(t,L,a),i(L,_),i(_,ht),i(_,ma),i(_,gt),i(_,ra),ls.m(ve,_),i(L,ca),i(L,b),i(b,ut),i(b,oa),i(b,vt),i(b,ha),is.m(de,b),e(t,ps,a),e(t,B,a),e(t,ms,a),e(t,T,a),i(T,Pt),i(Pt,C),i(C,ga),rs.m(fe,C),i(C,cs),i(C,dt),i(C,ua),i(T,va),i(T,St),i(St,M),i(M,da),i(M,ft),i(M,fa),os.m(we,M),i(M,hs),e(t,gs,a),e(t,Y,a),e(t,us,a),e(t,wt,a),i(wt,d),i(d,wa),vs.m(xe,d),i(d,ds),fs.m(ye,d),i(d,ws),i(d,xt),i(d,xa),e(t,xs,a),e(t,W,a),e(t,ys,a),e(t,yt,a),i(yt,f),i(f,ya),_s.m(_e,f),i(f,bs),Cs.m(be,f),i(f,Ms),ks.m(Ce,f),i(f,As),e(t,Ls,a),e(t,D,a),e(t,Ts,a),e(t,J,a),e(t,zs,a),e(t,K,a),e(t,$s,a),e(t,z,a),i(z,Ht),i(Ht,k),i(k,_a),Es.m(Me,k),i(k,Ps),Ss.m(ke,k),i(k,Hs),i(z,ba),i(z,_t),e(t,Is,a),e(t,X,a),e(t,qs,a),Gt(Z,t,a),e(t,js,a),e(t,tt,a),e(t,Gs,a),e(t,st,a),e(t,Rs,a),e(t,at,a),e(t,Os,a),e(t,et,a),e(t,Us,a),e(t,nt,a),e(t,Ns,a),e(t,lt,a),e(t,Qs,a),e(t,w,a),i(w,Ca),Fs.m(Ae,w),i(w,Vs),Bs.m(Le,w),i(w,Ys),i(w,bt),e(t,Ws,a),e(t,it,a),e(t,Ds,a),Gt(pt,t,a),e(t,Js,a),e(t,It,a),Ks=!0},p:ze,i(t){Ks||(Rt(S.$$.fragment,t),Rt(H.$$.fragment,t),Rt(Q.$$.fragment,t),Rt(Z.$$.fragment,t),Rt(pt.$$.fragment,t),Ks=!0)},o(t){Ot(S.$$.fragment,t),Ot(H.$$.fragment,t),Ot(Q.$$.fragment,t),Ot(Z.$$.fragment,t),Ot(pt.$$.fragment,t),Ks=!1},d(t){t&&(s(Nt),s(zt),s(Qt),s(Ft),s(Vt),s(I),s(Bt),s(q),s(Yt),s(j),s(Wt),s(G),s(Dt),s(R),s(Jt),s(O),s(Kt),s(U),s(Xt),s(A),s(ss),s(as),s(F),s(es),s(V),s(ns),s(L),s(ps),s(B),s(ms),s(T),s(gs),s(Y),s(us),s(wt),s(xs),s(W),s(ys),s(yt),s(Ls),s(D),s(Ts),s(J),s(zs),s(K),s($s),s(z),s(Is),s(X),s(qs),s(js),s(tt),s(Gs),s(st),s(Rs),s(at),s(Os),s(et),s(Us),s(nt),s(Ns),s(lt),s(Qs),s(w),s(Ws),s(it),s(Ds),s(Js),s(It)),s(x),Ut(S,t),Ut(H,t),Ut(Q,t),Ut(Z,t),Ut(pt,t)}}}const qe='{"title":"Advantage Actor-Critic (A2C)","local":"advantage-actor-critic","sections":[{"title":"Reducing variance with Actor-Critic methods","local":"reducing-variance-with-actor-critic-methods","sections":[],"depth":2},{"title":"The Actor-Critic Process","local":"the-actor-critic-process","sections":[],"depth":2},{"title":"Adding Advantage in Actor-Critic (A2C)","local":"adding-advantage-in-actor-critic-a2c","sections":[],"depth":2}],"depth":1}';function je(Ma){return $e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ue extends Ee{constructor(x){super(),Pe(this,x,je,Ie,Te,{})}}export{Ue as component};
